diff -Naur v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_cfg.c v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_cfg.c
--- v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_cfg.c	2021-05-28 13:21:44.439337854 +0800
+++ v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_cfg.c	2021-05-28 13:45:16.881340853 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014,2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014,2016,2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -93,6 +93,7 @@
 #else
 	cfg_ctx->defrag_timeout_check = 0;
 #endif
+	cfg_ctx->dup_check = 0;
 	cfg_ctx->max_peer_id = 511;
 	cfg_ctx->max_vdev = CFG_TGT_NUM_VDEV;
 	cfg_ctx->pn_rx_fwd_check = 1;
@@ -282,12 +283,18 @@
 	return cfg->tx_download_size;
 }
 
-int ol_cfg_rx_host_defrag_timeout_duplicate_check(ol_pdev_handle pdev)
+int ol_cfg_rx_host_defrag_timeout_check(ol_pdev_handle pdev)
 {
 	struct txrx_pdev_cfg_t *cfg = (struct txrx_pdev_cfg_t *)pdev;
 	return cfg->defrag_timeout_check;
 }
 
+int ol_cfg_rx_host_duplicate_check(ol_pdev_handle pdev)
+{
+	struct txrx_pdev_cfg_t *cfg = (struct txrx_pdev_cfg_t *)pdev;
+	return cfg->dup_check;
+}
+
 int ol_cfg_throttle_period_ms(ol_pdev_handle pdev)
 {
 	struct txrx_pdev_cfg_t *cfg = (struct txrx_pdev_cfg_t *)pdev;
diff -Naur v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c
--- v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c	2021-05-28 13:21:44.439337854 +0800
+++ v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c	2021-05-28 13:49:20.007125387 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014, 2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2016,2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -275,6 +275,8 @@
     struct ol_rx_reorder_array_elem_t *rx_reorder_array_elem;
     u_int16_t frxseq, rxseq, seq;
     htt_pdev_handle htt_pdev = pdev->htt_pdev;
+    void *rx_desc;
+    int index;              /* unicast vs. multicast */
 
     seq = seq_num & peer->tids_rx_reorder[tid].win_sz_mask;
     adf_os_assert(seq == 0);
@@ -287,13 +289,49 @@
         IEEE80211_SEQ_FRAG_MASK;
     more_frag = mac_hdr->i_fc[1] & IEEE80211_FC1_MORE_FRAG;
 
+    /*
+     * CR 2868034
+     * A broadcast or multicast frame should never be fragmented
+     * driver should drop all fragmented broadcast / multicast frames.
+     */
+    rx_desc = htt_rx_msdu_desc_retrieve(htt_pdev, frag);
+    if (htt_rx_msdu_is_wlan_mcast(htt_pdev, rx_desc)) {
+        /* Discard Mcast/Bcast single frag frames */
+        ol_rx_frames_free(htt_pdev, frag);
+
+        VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+            "%s: QSV2020004 discard MCAST/BCAST frag frame\n\n",
+            __FUNCTION__);
+        return;
+    }
+
+    index = htt_rx_msdu_is_wlan_mcast(htt_pdev, rx_desc) ?
+                txrx_sec_mcast : txrx_sec_ucast;
+
+    if (peer->security[index].sec_type != htt_sec_type_none &&
+        !htt_rx_mpdu_is_encrypted(htt_pdev, rx_desc)) {
+        ol_rx_frames_free(htt_pdev, frag);
+
+        VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+            "%s: QSV2020004, Unencrypted fragment received in security mode %d\n",
+            __FUNCTION__,
+            peer->security[index].sec_type);
+
+        return;
+    }
+
     if ((!more_frag) && (!fragno) && (!rx_reorder_array_elem->head)) {
-        ol_rx_fraglist_insert(htt_pdev, &rx_reorder_array_elem->head,
+        ol_rx_fraglist_insert(htt_pdev, peer,
+            &rx_reorder_array_elem->head,
             &rx_reorder_array_elem->tail, frag, &all_frag_present);
         adf_nbuf_set_next(frag, NULL);
         ol_rx_defrag(pdev, peer, tid, rx_reorder_array_elem->head);
         rx_reorder_array_elem->head = NULL;
         rx_reorder_array_elem->tail = NULL;
+
+        VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+            "%s: QSV2020008 not expected behavior, but also handled\n",
+            __FUNCTION__);
         return;
     }
     if (rx_reorder_array_elem->head) {
@@ -314,7 +352,8 @@
         }
     }
 
-    ol_rx_fraglist_insert(htt_pdev, &rx_reorder_array_elem->head,
+    ol_rx_fraglist_insert(htt_pdev, peer,
+        &rx_reorder_array_elem->head,
         &rx_reorder_array_elem->tail, frag, &all_frag_present);
 
     if (pdev->rx.flags.defrag_timeout_check) {
@@ -341,6 +380,7 @@
 void
 ol_rx_fraglist_insert(
     htt_pdev_handle htt_pdev,
+    struct ol_txrx_peer_t *peer,
     adf_nbuf_t *head_addr,
     adf_nbuf_t *tail_addr,
     adf_nbuf_t frag,
@@ -350,6 +390,10 @@
     struct ieee80211_frame *mac_hdr, *cmac_hdr, *next_hdr, *lmac_hdr;
     u_int8_t fragno, cur_fragno, lfragno, next_fragno;
     u_int8_t last_morefrag = 1, count = 0;
+    int pn_len = 0;
+    void *rx_desc;
+    int index;              /* unicast vs. multicast */
+    union htt_rx_pn_t curr_pn, next_pn;
 
     adf_os_assert(frag);
 
@@ -385,6 +429,10 @@
         if (fragno == cur_fragno) {
             htt_rx_desc_frame_free(htt_pdev, frag);
             *all_frag_present = 0;
+            VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+                   "\n%s:Duplicated frag No, fragno = %u, discard it\n",
+                   __FUNCTION__,
+                   fragno);
             return;
         } else {
             adf_nbuf_set_next(prev, frag);
@@ -396,15 +444,63 @@
                                                                 *tail_addr);
     last_morefrag = lmac_hdr->i_fc[1] & IEEE80211_FC1_MORE_FRAG;
     if (!last_morefrag) {
+        rx_desc = htt_rx_msdu_desc_retrieve(htt_pdev, *head_addr);
+        index = htt_rx_msdu_is_wlan_mcast(htt_pdev, rx_desc) ?
+                txrx_sec_mcast : txrx_sec_ucast;
+        pn_len = htt_pdev->txrx_pdev->rx_pn[peer->security[index].sec_type].len;
+        if (pn_len) {
+            htt_rx_mpdu_desc_pn(htt_pdev, rx_desc, &curr_pn, pn_len);
+        }
+
         do {
             next_hdr = (struct ieee80211_frame *) OL_RX_FRAG_GET_MAC_HDR(
                                                                 htt_pdev, next);
             next_fragno = adf_os_le16_to_cpu(*(u_int16_t *) next_hdr->i_seq) &
                 IEEE80211_SEQ_FRAG_MASK;
+
+			/*
+			 * CR 2868016
+			 * Perform strict PN check if non-consecutive
+			 * discard all frags
+			 */
+			if (pn_len) {
+				/* retrieve PN from rx descriptor */
+			    rx_desc = htt_rx_msdu_desc_retrieve(htt_pdev, next);
+			    htt_rx_mpdu_desc_pn(htt_pdev, rx_desc, &next_pn, pn_len);
+			}
+
             count++;
+			/*
+			 * Fragment number consecutive is gauranteed
+			 * by count++, all_frage_present only set to
+			 * 1 when checking complete, otherwise, frags
+			 * will be discard due to timeout
+			 */
+
             if (next_fragno != count) {
                 break;
             }
+
+			if (pn_len) {
+				if(!ol_rx_pn_strict_chk(&next_pn,
+				    &curr_pn,
+				    index == txrx_sec_ucast,
+				    pn_len,
+				    peer->vdev->opmode)) {
+					VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+                               "\n%s:QSV2020003 expected discard non-strict PN behavior, curr_pn=%llu, next_pn=%llu\n",
+                               __FUNCTION__,
+                               curr_pn.pn48,
+                               next_pn.pn48
+                               );
+					break;
+				}
+
+				vos_mem_copy((uint8_t *) &curr_pn,
+					         (uint8_t *) &next_pn,
+					         sizeof(union htt_rx_pn_t));
+			}
+
             next = adf_nbuf_next(next);
         } while (next);
 
diff -Naur v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h
--- v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h	2021-05-28 13:21:44.439337854 +0800
+++ v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h	2021-05-28 13:45:31.574517330 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -63,6 +63,7 @@
 void
 ol_rx_fraglist_insert(
     htt_pdev_handle htt_pdev,
+    struct ol_txrx_peer_t *peer,
     adf_nbuf_t *head_addr,
     adf_nbuf_t *tail_addr,
     adf_nbuf_t frag,
diff -Naur v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c
--- v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c	2021-05-28 13:21:44.439337854 +0800
+++ v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c	2021-05-28 13:50:20.240367713 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011, 2014, 2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011, 2014, 2016, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -229,6 +229,33 @@
              * in which case we need to make a copy (or clone?).
              */
             if (!do_not_fwd) {
+                u_int16_t off = 0;
+                // for HL, point to payload right now
+                if (pdev->cfg.is_high_latency) {
+                    off = htt_rx_msdu_rx_desc_size_hl(pdev->htt_pdev,
+                                                      rx_desc);
+                }
+
+                /*
+                 * CR 2868053
+                 * discard EAPOL frame for intrabss forwarding
+                 */
+                if ((vdev->opmode == wlan_op_mode_ap) &&
+                    __adf_nbuf_data_is_eapol_pkt(adf_nbuf_data(msdu) + off)) {
+                    VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+                        "\n%s:QSV2020005 EAPOL forwarding discard \n",
+                        __FUNCTION__);
+                    /* Drop the packet*/
+                    htt_rx_msdu_desc_free(pdev->htt_pdev, msdu);
+                    TXRX_STATS_MSDU_LIST_INCR(
+                        pdev, tx.dropped.host_reject, msdu);
+                    /* add NULL terminator */
+                    adf_nbuf_set_next(msdu, NULL);
+                    adf_nbuf_tx_free(msdu, ADF_NBUF_PKT_ERROR);
+                    msdu = msdu_list;
+                    continue;
+                }
+
                 if (htt_rx_msdu_discard(pdev->htt_pdev, rx_desc)) {
                         htt_rx_msdu_desc_free(pdev->htt_pdev, msdu);
                         adf_net_buf_debug_release_skb(msdu);
diff -Naur v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.c v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_pn.c
--- v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.c	2021-05-28 13:21:44.443337865 +0800
+++ v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_pn.c	2021-05-28 13:41:59.074873111 +0800
@@ -91,6 +91,34 @@
     return pn_is_replay;
 }
 
+int ol_rx_pn_strict_chk(union htt_rx_pn_t *new_pn,
+		      union htt_rx_pn_t *old_pn,
+		      int is_unicast, int pn_len,
+		      int opmode)
+{
+    int rc = 0;
+
+    if (pn_len == 24) {
+	    rc = ((new_pn->pn24 & 0xffffff) == ((old_pn->pn24 & 0xffffff) + 1));
+	    return rc;
+    }
+
+    /* TKIP: 48-bit TSC, CCMP: 48-bit PN */
+    if (pn_len == 48) {
+	    rc = ((new_pn->pn48 & 0xffffffffffffULL) ==
+		  ((old_pn->pn48 & 0xffffffffffffULL) + 1));
+	    return rc;
+    }
+
+    /* WAPI: 128-bit PN */
+    if (pn_len == 128) {
+        /* TODO WAPI is not implemented, bypass this checking*/
+        rc = 1;
+    }
+
+    return rc;
+}
+
 adf_nbuf_t
 ol_rx_pn_check_base(
     struct ol_txrx_vdev_t *vdev,
diff -Naur v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.h v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_pn.h
--- v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.h	2021-05-28 13:21:44.443337865 +0800
+++ v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_rx_pn.h	2021-05-28 13:41:59.074873111 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -118,5 +118,19 @@
     unsigned tid,
     adf_nbuf_t msdu_list);
 
+/**
+ * @brief If applicable, check the Packet Number to strict mathcing old +1 = new.
+ *
+ * @param new_pn - which includes new pn data
+ * @param old_pn - which includes old pn data
+ * @param is_unicast - unicsat frame or mcast frame for WAPI
+ * @param pn_len - pn length
+ * @param op_mode - op mode used for WAPI
+ * @return list of netbufs that didn't fail the PN check
+ */
+int ol_rx_pn_strict_chk(union htt_rx_pn_t *new_pn,
+		      union htt_rx_pn_t *old_pn,
+		      int is_unicast, int pn_len,
+		      int opmode);
 
 #endif /* _OL_RX_PN_H_ */
diff -Naur v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_txrx.c v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_txrx.c
--- v4.0.11.203-org/CORE/CLD_TXRX/TXRX/ol_txrx.c	2021-05-28 13:21:44.443337865 +0800
+++ v4.0.11.203/CORE/CLD_TXRX/TXRX/ol_txrx.c	2021-05-28 13:43:57.437764565 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2016, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -552,8 +552,13 @@
 
     /* configure where defrag timeout and duplicate detection is handled */
     pdev->rx.flags.defrag_timeout_check =
-        pdev->rx.flags.dup_check =
-            ol_cfg_rx_host_defrag_timeout_duplicate_check(ctrl_pdev);
+            ol_cfg_rx_host_defrag_timeout_check(ctrl_pdev);
+    pdev->rx.flags.dup_check =
+            ol_cfg_rx_host_duplicate_check(ctrl_pdev);
+
+    if (pdev->rx.flags.defrag_timeout_check) {
+        pdev->rx.defrag.timeout_ms = DEFRAG_MIN_TIMEOUT_MS;
+    }
 
 #ifdef QCA_SUPPORT_SW_TXRX_ENCAP
     /* Need to revisit this part. Currently,hardcode to riva's caps */
diff -Naur v4.0.11.203-org/CORE/HDD/inc/wlan_hdd_cfg.h v4.0.11.203/CORE/HDD/inc/wlan_hdd_cfg.h
--- v4.0.11.203-org/CORE/HDD/inc/wlan_hdd_cfg.h	2021-05-28 13:21:44.443337865 +0800
+++ v4.0.11.203/CORE/HDD/inc/wlan_hdd_cfg.h	2021-05-28 13:53:14.301816031 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012-2017 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012-2017,2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -2747,6 +2747,18 @@
 #define CFG_ENABLE_DEBUG_CONNECT_ISSUE_DEFAULT     (0x76)
 
 /*
+ * Eapol sanity checking Enable/Disable for SAP.
+ * 0x0 - Enable eapol sanity checking in the RX path
+ *       before deliver to the OS in the SAP mode.
+ * 0x1 - Enable eapol sanity checking in the RX path
+ *       before deliver to the OS in the SAP mode.
+ */
+#define CFG_ENABLE_SAP_EAPOL_CHECKING             "gEnableSapEapolChecking"
+#define CFG_ENABLE_SAP_EAPOL_CHECKING_MIN         (0)
+#define CFG_ENABLE_SAP_EAPOL_CHECKING_MAX         (1)
+#define CFG_ENABLE_SAP_EAPOL_CHECKING_DEFAULT     (1)
+
+/*
  * RX packet handling options
  * 0: no rx thread, no RPS, for MDM
  * 1: RX thread
@@ -4938,6 +4950,7 @@
    v_U32_t                     TxPower2g;
    v_U32_t                     TxPower5g;
    v_U32_t                     gEnableDebugLog;
+   v_U32_t                     gEnableSapEapolChecking;
    v_U8_t                      rxhandle;
    uint8_t                     cpu_map_list[CFG_RPS_RX_QUEUE_CPU_MAP_LIST_LEN];
    v_BOOL_t                    fDfsPhyerrFilterOffload;
diff -Naur v4.0.11.203-org/CORE/HDD/src/wlan_hdd_cfg.c v4.0.11.203/CORE/HDD/src/wlan_hdd_cfg.c
--- v4.0.11.203-org/CORE/HDD/src/wlan_hdd_cfg.c	2021-05-28 13:21:44.443337865 +0800
+++ v4.0.11.203/CORE/HDD/src/wlan_hdd_cfg.c	2021-05-28 13:53:56.279799597 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012-2017 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012-2017,2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -3309,6 +3309,13 @@
                  CFG_ENABLE_DEBUG_CONNECT_ISSUE_MIN ,
                  CFG_ENABLE_DEBUG_CONNECT_ISSUE_MAX),
 
+   REG_VARIABLE( CFG_ENABLE_SAP_EAPOL_CHECKING, WLAN_PARAM_Integer,
+                 hdd_config_t, gEnableSapEapolChecking,
+                 VAR_FLAGS_OPTIONAL | VAR_FLAGS_RANGE_CHECK_ASSUME_DEFAULT,
+                 CFG_ENABLE_SAP_EAPOL_CHECKING_DEFAULT,
+                 CFG_ENABLE_SAP_EAPOL_CHECKING_MIN ,
+                 CFG_ENABLE_SAP_EAPOL_CHECKING_MAX),
+
    REG_VARIABLE( CFG_RX_HANDLE, WLAN_PARAM_Integer,
                  hdd_config_t, rxhandle,
                  VAR_FLAGS_OPTIONAL | VAR_FLAGS_RANGE_CHECK_ASSUME_DEFAULT,
diff -Naur v4.0.11.203-org/CORE/HDD/src/wlan_hdd_ipa.c v4.0.11.203/CORE/HDD/src/wlan_hdd_ipa.c
--- v4.0.11.203-org/CORE/HDD/src/wlan_hdd_ipa.c	2021-05-28 13:21:44.443337865 +0800
+++ v4.0.11.203/CORE/HDD/src/wlan_hdd_ipa.c	2021-05-28 13:56:00.637369242 +0800
@@ -2991,6 +2991,7 @@
 #endif
 	struct hdd_ipa_priv *hdd_ipa = ghdd_ipa;
 	unsigned int cpu_index;
+	hdd_context_t *pHddCtx = NULL;
 
 	if (!adapter || adapter->magic != WLAN_HDD_ADAPTER_MAGIC) {
 		HDD_IPA_LOG(VOS_TRACE_LEVEL_INFO_LOW, "Invalid adapter: 0x%p",
@@ -3006,6 +3007,36 @@
 		return;
 	}
 
+	pHddCtx = (hdd_context_t *)adapter->pHddCtx;
+	if (pHddCtx->cfg_ini->gEnableSapEapolChecking &&
+		(adapter->device_mode == WLAN_HDD_SOFTAP ||
+		adapter->device_mode == WLAN_HDD_P2P_GO) &&
+		adf_nbuf_is_eapol_pkt(skb)) {
+
+		/* CR 2868053 */
+		HDD_IPA_LOG(VOS_TRACE_LEVEL_INFO,
+				"QSV2020005, dev, mode=%d, session=%u, %s, addr (%pM)",
+				adapter->device_mode,
+				adapter->sessionId,
+				adapter->dev->name,
+				adapter->dev->dev_addr);
+		HDD_IPA_LOG(VOS_TRACE_LEVEL_INFO,
+				"QSV2020005 pkt addr (%pM)",
+				skb->data);
+		if (adf_os_mem_cmp(adapter->dev->dev_addr,
+			skb->data, VOS_MAC_ADDR_SIZE)) {
+			/* CR 2868053, discard this EAPOL */
+			HDD_IPA_LOG(VOS_TRACE_LEVEL_ERROR,
+					"QSV2020005 discard invalid EAPOL frame, dev=%pM, "
+					"pkt_da=%pM",
+					adapter->dev->dev_addr,
+					skb->data);
+
+			adf_nbuf_free(skb);
+			return;
+		}
+	}
+
 	skb->destructor = hdd_ipa_uc_rt_debug_destructor;
 	skb->dev = adapter->dev;
 	skb->protocol = eth_type_trans(skb, skb->dev);
@@ -3236,6 +3267,20 @@
 				"Forward packet to Tx (fw_desc=%d)", desc);
 		hdd_ipa->ipa_tx_forward++;
 
+		/*
+		* CR 2868053
+		* discard EAPOL frame for intrabss forwarding
+		*/
+		if (adf_nbuf_is_eapol_pkt(skb)) {
+			HDD_IPA_DP_LOG(VOS_TRACE_LEVEL_ERROR,
+					"QSV2020005 EAPOL forwarding discard \n");
+			/* Drop the packet*/
+			hdd_ipa->ipa_rx_internel_drop_count++;
+			hdd_ipa->ipa_rx_discard++;
+			ret = HDD_IPA_FORWARD_PKT_DISCARD;
+			goto out;
+		}
+
 		if ((desc & FW_RX_DESC_DISCARD_M)) {
 			xmit_status = hdd_softap_hard_start_xmit(
 							skb, adapter->dev);
@@ -3254,6 +3299,7 @@
 			ret = HDD_IPA_FORWARD_PKT_LOCAL_STACK;
 		}
 
+out:
 		if (NETDEV_TX_OK == xmit_status) {
 			hdd_ipa->stats.num_tx_fwd_ok++;
 		} else {
diff -Naur v4.0.11.203-org/CORE/HDD/src/wlan_hdd_softap_tx_rx.c v4.0.11.203/CORE/HDD/src/wlan_hdd_softap_tx_rx.c
--- v4.0.11.203-org/CORE/HDD/src/wlan_hdd_softap_tx_rx.c	2021-05-28 13:21:44.443337865 +0800
+++ v4.0.11.203/CORE/HDD/src/wlan_hdd_softap_tx_rx.c	2021-05-28 13:54:15.846409354 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012-2017 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012-2017,2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -920,6 +920,37 @@
       }
 #endif /* QCA_PKT_PROTO_TRACE */
 
+      if (pHddCtx->cfg_ini->gEnableSapEapolChecking) {
+          if (adf_nbuf_is_eapol_pkt(skb)) {
+              /* CR 2868053 */
+              VOS_TRACE(VOS_MODULE_ID_HDD_DATA, VOS_TRACE_LEVEL_INFO,
+                  "%s: QSV2020005, dev, mode=%d, session=%u, %s, addr (%pM)",
+                  __FUNCTION__,
+                  pAdapter->device_mode,
+                  pAdapter->sessionId,
+                  pAdapter->dev->name,
+                  pAdapter->dev->dev_addr);
+              VOS_TRACE(VOS_MODULE_ID_HDD_DATA, VOS_TRACE_LEVEL_INFO,
+                  "%s:QSV2020005 pkt addr (%pM)",
+                  __FUNCTION__,
+                  skb->data);
+              if (adf_os_mem_cmp(pAdapter->dev->dev_addr,
+                skb->data, VOS_MAC_ADDR_SIZE)) {
+                  /* CR 2868053, discard this EAPOL */
+                  VOS_TRACE(VOS_MODULE_ID_HDD_DATA, VOS_TRACE_LEVEL_ERROR,
+                      "%s:QSV2020005 discard invalid EAPOL frame, dev=%pM, "
+                      "pkt_da=%pM",
+                      __FUNCTION__,
+                      pAdapter->dev->dev_addr,
+                      skb->data);
+
+                  adf_nbuf_free(skb);
+                  skb = skb_next;
+                  continue;
+              }
+          }
+      }
+
       skb->protocol = eth_type_trans(skb, skb->dev);
 
       /**
diff -Naur v4.0.11.203-org/CORE/SERVICES/COMMON/ol_cfg.h v4.0.11.203/CORE/SERVICES/COMMON/ol_cfg.h
--- v4.0.11.203-org/CORE/SERVICES/COMMON/ol_cfg.h	2021-05-28 13:21:44.455337899 +0800
+++ v4.0.11.203/CORE/SERVICES/COMMON/ol_cfg.h	2021-05-28 13:47:35.654798092 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014, 2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2016, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -51,6 +51,12 @@
     wlan_frm_fmt_802_3,
 };
 
+#if CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK
+#define DEFRAG_MIN_TIMEOUT_MS 100
+#else
+#define DEFRAG_MIN_TIMEOUT_MS 0
+#endif
+
 /* Throttle period Different level Duty Cycle values*/
 #define THROTTLE_DUTY_CYCLE_LEVEL0 (0)
 #define THROTTLE_DUTY_CYCLE_LEVEL1 (50)
@@ -71,6 +77,7 @@
 struct txrx_pdev_cfg_t {
 	u8 is_high_latency;
 	u8 defrag_timeout_check;
+    u8 dup_check;
 	u8 rx_pn_check;
 	u8 pn_rx_fwd_check;
 	u8 host_addba;
@@ -331,7 +338,25 @@
 int ol_cfg_tx_download_size(ol_pdev_handle pdev);
 
 /**
- * brief Specify where defrag timeout and duplicate detection is handled
+ * brief Specify where defrag timeout is handled
+ * @details
+ *   non-aggregate duplicate detection and timing out stale fragments
+ *   requires additional target memory. To reach max client
+ *   configurations (128+), non-aggregate duplicate detection and the
+ *   logic to time out stale fragments is moved to the host.
+ *
+ * @param pdev - handle to the physical device
+ * @return
+ *  0 -> target is responsible non-aggregate duplicate detection and
+ *          timing out stale fragments.
+ *
+ *  1 -> host is responsible non-aggregate duplicate detection and
+ *          timing out stale fragments.
+ */
+int ol_cfg_rx_host_defrag_timeout_check(ol_pdev_handle pdev);
+
+/**
+ * brief Specify where duplicate detection is handled
  * @details
  *   non-aggregate duplicate detection and timing out stale fragments
  *   requires additional target memory. To reach max client
@@ -346,7 +371,7 @@
  *  1 -> host is responsible non-aggregate duplicate detection and
  *          timing out stale fragments.
  */
-int ol_cfg_rx_host_defrag_timeout_duplicate_check(ol_pdev_handle pdev);
+int ol_cfg_rx_host_duplicate_check(ol_pdev_handle pdev);
 
 /**
  * brief Query for the period in ms used for throttling for
diff -Naur v4.0.11.203-org/CORE/SERVICES/COMMON/wlan_tgt_def_config.h v4.0.11.203/CORE/SERVICES/COMMON/wlan_tgt_def_config.h
--- v4.0.11.203-org/CORE/SERVICES/COMMON/wlan_tgt_def_config.h	2021-05-28 13:21:44.455337899 +0800
+++ v4.0.11.203/CORE/SERVICES/COMMON/wlan_tgt_def_config.h	2021-05-28 13:46:57.480195130 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011, 2014-2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011, 2014-2016, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -172,7 +172,7 @@
 #define CFG_TGT_DEFAULT_TX_DBG_LOG_SIZE 1024 /* bytes */
 
 /* target based fragment timeout and MPDU duplicate detection */
-#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 0
+#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 1
 
 /*  Default VoW configuration
  */
diff -Naur v4.0.11.203-org/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h v4.0.11.203/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h
--- v4.0.11.203-org/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h	2021-05-28 13:21:44.455337899 +0800
+++ v4.0.11.203/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h	2021-05-28 13:41:59.074873111 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2013-2016 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2013-2016, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -209,7 +209,7 @@
 #define CFG_TGT_DEFAULT_TX_DBG_LOG_SIZE 1024 /* bytes */
 
 /* target based fragment timeout and MPDU duplicate detection */
-#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 0
+#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 1
 /*  Default VoW configuration
  */
 #define CFG_TGT_DEFAULT_VOW_CONFIG   0
diff -Naur v4.0.11.203-org/CORE/SERVICES/WMA/wma.c v4.0.11.203/CORE/SERVICES/WMA/wma.c
--- v4.0.11.203-org/CORE/SERVICES/WMA/wma.c	2021-05-28 13:21:44.459337910 +0800
+++ v4.0.11.203/CORE/SERVICES/WMA/wma.c	2021-05-28 13:35:43.049935315 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2013-2017 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2013-2017, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -112,6 +112,7 @@
 #include "wma_ocb.h"
 #include "wma_nan_datapath.h"
 
+#include "ol_rx_reorder.h"
 /* ################### defines ################### */
 /*
  * TODO: Following constant should be shared by firwmare in
@@ -18922,6 +18923,12 @@
 		}
 	}
 
+        WMA_LOGD("%s: QSV2020002, vid(%u), rx cleanup for peer(%pM) after key install",
+            __func__,
+            txrx_vdev->vdev_id,
+            peer->mac_addr.raw);
+        ol_rx_reorder_peer_cleanup(txrx_vdev, peer);
+
         /* In IBSS mode, set the BSS KEY for this peer
          ** BSS key is supposed to be cache into wma_handle
         */
